'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Esspired = function () {
  function Esspired() {
    _classCallCheck(this, Esspired);

    this.length = window.sessionStorage.length;
  }

  _createClass(Esspired, [{
    key: "key",
    value: function key(n) {
      return window.sessionStorage.key(n);
    }
  }, {
    key: "getItem",
    value: function getItem(key) {
      var item = window.sessionStorage.getItem(key);
      try {
        var entry = JSON.parse(item);

        // return entry as is if not an esspired entry.
        if (!entry.data && !entry.expire) {
          return entry;
        }

        var data = entry.data;
        var expire = entry.expire;

        var now = new Date();
        var expiration = new Date(expire);

        if (expire !== -1 && now.getTime() > expiration.getTime()) {
          window.sessionStorage.removeItem(key);
          return null;
        }

        return data;
      } catch (e) {
        // return item as is if not an object.
        return item;
      }
    }
  }, {
    key: "setItem",
    value: function setItem(key, data) {
      var expire = arguments.length <= 2 || arguments[2] === undefined ? -1 : arguments[2];

      var entry = { data: data, expire: expire };
      return window.sessionStorage.setItem(key, JSON.stringify(entry));
    }
  }, {
    key: "removeItem",
    value: function removeItem(key) {
      return window.sessionStorage.removeItem(key);
    }
  }, {
    key: "clear",
    value: function clear() {
      return window.sessionStorage.clear();
    }
  }]);

  return Esspired;
}();

var hasSessionStorage = "sessionStorage" in window && window.sessionStorage;
if (!hasSessionStorage) {
  console.warn("sessionStorage is not available");
}
module.exports = new Esspired();